/**@file

// unShelvedAE_TableParameters.ctl
This library contains the unShelvedAE_TableParameters class that is used to configure (set/get the values) for the
parameters of the table of unShelved Alarms and Events

@par Creation Date
  15/09/2022

@par Modification History

@par Constraints
  None

@par Usage
  Public

@par PVSS managers
  Ui, CTRL

@author
  Juan-Manuel Pablo-Rodriguez

@copyright
        Copyright CERN 2022 - all rights reserved
*/

class unShelvedAE_TableParameters
{
  private dyn_string dsAlias;
  private dyn_string dsType;
  private dyn_string dsSystem;
  private dyn_string dsTimestamp;
  private dyn_string dsApplication;
  private dyn_string dsDescription;
  private dyn_string dsNature;
  private dyn_string dsComments;

  public unShelvedAE_TableParameters(dyn_string dsAlias, dyn_string dsType, dyn_string dsSystem, dyn_string dsTimestamp,
                                     dyn_string dsApplication, dyn_string dsDescription, dyn_string dsNature, dyn_string dsComments) {
    this.dsAlias = dsAlias;
    this.dsType = dsType;
    this.dsSystem = dsSystem;
    this.dsTimestamp = dsTimestamp;
    this.dsApplication = dsApplication;
    this.dsDescription = dsDescription;
    this.dsNature = dsNature;
    this.dsComments = dsComments;
  }

  public dyn_string getAliases() {
    return this.dsAlias;
  }

  public void setAliases(dyn_string dsAlias) {
    this.dsAlias = dsAlias;
  }

  public dyn_string getTypes() {
    return this.dsType;
  }

  public void setTypes(dyn_string dsType) {
    this.dsType = dsType;
  }

  public dyn_string getSystems() {
    return this.dsSystem;
  }

  public void setSystems(dyn_string dsSystem) {
    this.dsSystem = dsSystem;
  }

  public dyn_string getTimestamps() {
    return this.dsTimestamp;
  }

  public void setTimestamps(dyn_string dsTimestamp) {
    this.dsTimestamp = dsTimestamp;
  }

  public dyn_string getApplications() {
    return this.dsApplication;
  }

  public void setApplications(dyn_string dsApplication) {
    this.dsApplication = dsApplication;
  }

  public dyn_string getDescriptions() {
    return this.dsDescription;
  }

  public void setDescriptions(dyn_string dsDescription) {
    this.dsDescription = dsDescription;
  }

  public dyn_string getNatures() {
    return this.dsNature;
  }

  public void setNatures(dyn_string dsNature) {
    this.dsNature = dsNature;
  }

  public dyn_string getComments() {
    return this.dsComments;
  }

  public void setComments(dyn_string dsComments) {
    this.dsComments = dsComments;
  }

};
