#uses "unSystemIntegrity_unRcpPeriodicSaving.ctl"
#uses "unRcpDbFunctions.ctl"
#uses "unFilterDpFunctions.ctl"

void main()
{
  string query = "SELECT '.interval:_original.._value' FROM '_RecipeBackup/*' WHERE _DPT = \"_TimedFunc\"";
  int iRes = dpQueryConnectSingle("timedCall", true, "", query);
  if(iRes) {
	DebugTN(__FUNCTION__, __LINE__, "ERROR", "Cannot monitor change of configuration values for recipes", iRes, getLastError());
  }
}

timedCall(anytype userData, dyn_anytype result) {
  for (int i=2; i<= dynlen(result); i++) {
	int rc = timedFunc("saveUnRecipe",result[i][1]);
	if(rc) {
	  DebugTN(__FUNCTION__, __LINE__, "ERROR", "Cannot save the recipe configuration for " + result[i][1], rc, getLastError());
	}
  }
}

saveUnRecipe(string dp, time t1, time t2) {
	unRcpPeriodicSaving_alarmDescription = _saveUnRecipe(dp);
 unSystemIntegrity_unRcpPeriodicSaving_writeErrorCode(c_unSystemIntegrity_unRcpPeriodicSaving_AlertLevel_FailurePeriodicSaving);
}

string _saveUnRecipe(string dp) {
  dyn_string dsRcpDbList, dsDpNames, exceptionInfo;
  string comment, className, instanceName, recipeName, query;
  dyn_string dsDp = strsplit(dp, UN_RECIPE_DELIMETER_CHAR);
  string alarmDescription;

  if (dynlen(dsDp) >= 3) {
	className = dsDp[2];
	instanceName = dsDp[3];
	recipeName = className + UN_RECIPE_DELIMETER_CHAR + instanceName;
	query = "SELECT '.ProcessInput.InstanceName:_online.._value' FROM '*' WHERE '.ProcessInput.InstanceName:_online.._value' = \""
				  + instanceName + "\" AND '.ProcessInput.ClassName:_online.._value' = \"" + className
				  + "\" AND _DPT=\"" + UN_CONFIG_UNRCPINSTANCE_DPT_NAME + "\" ";

	unFilterDpFunctions_dpQuery(query, dsDpNames);

	// Check the current status of the DB connection
    fwConfigurationDB_initialize("", exceptionInfo);
    if (dynlen(exceptionInfo)) {
      DebugTN(__FUNCTION__, __LINE__, exceptionInfo);
      alarmDescription = "" + recipeName + ", Cannot initialize DB connection";
      return alarmDescription;
    }

	// Get the list of recipes saved in the ORACLE database
	fwConfigurationDB_getRecipesInDB(dsRcpDbList, exceptionInfo);
	if (dynlen(exceptionInfo)) {
	  DebugTN(__FUNCTION__, __LINE__, exceptionInfo);
	  alarmDescription = "" + recipeName + ", cannot retrieve reciped from database";
	  return alarmDescription;
	}

	if(dpExists(recipeName)) {
	  dpGet(getSystemName() + recipeName + ".snapshotsDescription", comment);
	} else {
	  DebugTN(__FUNCTION__, __LINE__, "ERROR", "Recipe datapoint name " + recipeName + " does not exists", getLastException());
	  alarmDescription = "" + recipeName + ", datapoint name does not exist";
	  return alarmDescription;
	}
	_unRecipeFunctions_saveRecipeInstanceToDb(dsDpNames[1] + ".", className, instanceName, comment, dsRcpDbList, exceptionInfo, true);
	if (dynlen(exceptionInfo) && exceptionInfo[1] != "INFO") {
	  DebugTN(__FUNCTION__, __LINE__, exceptionInfo);
	  alarmDescription = "" + recipeName + ", have not been saved";
	  return alarmDescription;
	}
	else {
	  //Return message to display that the recipes have been saved
	  DebugTN(exceptionInfo);
	  alarmDescription = "";
	  return alarmDescription;
	}
  } else {
	DebugTN(__FUNCTION__, __LINE__, "ERROR", "Unable to obtain class name and instance name of recipe.");
	alarmDescription = "Unable to parse class/instance name of DP: " + dp;
	return alarmDescription;
  }
}

